(function($) {
  Drupal.behaviors.viewsResizableColumns = {
    attach: function(context) {
      // Use the new once function to select tables that haven't been processed yet
      const tables = once('views-resizable-columns', 'table.views-table', context);
      tables.forEach(function(table) {
        const $table = $(table);
        $table.find('thead th').each(function() {
          var $th = $(this);
          var $handle = $('<div class="resize-handle"></div>');
          $th.append($handle);
          $handle.on('mousedown', function(e) {
            e.preventDefault();
            $('body').addClass('resizing');
            var startX = e.pageX;
            var originalWidth = $th.width();
            var minWidth = 20;

            $(document).on('mousemove.resizable', function(e) {
              var newWidth = Math.max(minWidth, originalWidth + (e.pageX - startX));
              $th.width(newWidth);
            });

            $(document).on('mouseup.resizable', function() {
              $('body').removeClass('resizing');
              $(document).off('mousemove.resizable');
              $(document).off('mouseup.resizable');
            });
          });
        });
      });
    }
  };
})(jQuery);
